'use strict';

exports.__esModule = true;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Router = require('./Router');

var _Router2 = _interopRequireDefault(_Router);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createHref = function createHref(path) {
  return path;
};
var listen = function listen() {
  (0, _invariant2.default)(false, 'You cannot listen for location changes using <ServerRouter>');
};

var createLocation = function createLocation(url) {
  var pathname = url || '/';
  var search = '';
  var hash = '';

  var hashIndex = pathname.indexOf('#');
  if (hashIndex !== -1) {
    hash = pathname.substr(hashIndex);
    pathname = pathname.substr(0, hashIndex);
  }

  var searchIndex = pathname.indexOf('?');
  if (searchIndex !== -1) {
    search = pathname.substr(searchIndex);
    pathname = pathname.substr(0, searchIndex);
  }

  return {
    pathname: pathname,
    search: search === '?' ? '' : search,
    hash: hash === '#' ? '' : hash
  };
};

/**
 * The public top-level API for a server-side <Router>.
 */

var ServerRouter = function (_React$Component) {
  _inherits(ServerRouter, _React$Component);

  function ServerRouter() {
    var _temp, _this, _ret;

    _classCallCheck(this, ServerRouter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handlePush = function (location) {
      var context = _this.props.context;

      context.action = 'PUSH';
      context.location = location;
    }, _this.handleReplace = function (location) {
      var context = _this.props.context;

      context.action = 'REPLACE';
      context.location = location;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ServerRouter.prototype.getChildContext = function getChildContext() {
    return {
      history: {
        createHref: createHref,
        action: 'POP',
        location: createLocation(this.props.url),
        push: this.handlePush,
        replace: this.handleReplace,
        listen: listen
      }
    };
  };

  ServerRouter.prototype.render = function render() {
    var _props = this.props,
        url = _props.url,
        context = _props.context,
        props = _objectWithoutProperties(_props, ['url', 'context']); // eslint-disable-line no-unused-vars


    return _react2.default.createElement(_Router2.default, props);
  };

  return ServerRouter;
}(_react2.default.Component);

ServerRouter.propTypes = {
  url: _react.PropTypes.string.isRequired,
  context: _react.PropTypes.object.isRequired
};
ServerRouter.childContextTypes = {
  history: _react.PropTypes.object.isRequired
};
exports.default = ServerRouter;